import AEChooser

import pygtk
pygtk.require('2.0')
import gtk
import gtk.glade
from BeautifulSoup import BeautifulSoup
from urllib2 import urlopen
import re, os

__uie__ = dict(kind='chooser')

class PictureViewer(AEChooser.AEChooser):
  def init(self, text, **kwargs):
    self.curr = 0
    encoded = text.replace(' ', '+')
    url = 'http://www.flickr.com/search/?q=%s&l=comm' % text
    html = urlopen(url).read()
    soup = BeautifulSoup(html)
    self.imgs = soup.findAll('img', 
                             src=lambda x: x.find('buddyicons') == -1 and \
                             x.startswith('http://static.flickr.com'))
    authors = soup.findAll('p', attrs={'class' : 'PicFrom'})
    self.attrs = [author.find('a', style='text-decoration: none;') 
                  for author in authors]
    if not self.imgs:
      self._onCancel(None)
    
    source = gtk.glade.XML(self._getResource('picture_viewer.glade'))
    self.window = source.get_widget('window')
    self.image = source.get_widget('image')
    self.prev = source.get_widget('prev button')
    self.next = source.get_widget('next button')
    self.link = source.get_widget('link button')
    self.window.set_title(text)
    source.signal_autoconnect(self)
   
    self._showImage()
    self._updateButtons()

  def _onPrev(self, widget):
    self.curr -= 1
    self._showImage()
    self._updateButtons()
  
  def _onNext(self, widget):
    self.curr += 1
    self._showImage()
    self._updateButtons()
    
  def _updateButtons(self):
    self.prev.set_sensitive(self.curr > 0)
    self.next.set_sensitive(self.curr < len(self.imgs)-1)
    
  def _showImage(self):
    try:
      img = self.imgs[self.curr]
    except IndexError:
      return
    data = urlopen(img['src']).read()
    file(os.path.join(self.getPath(), 'img.jpg'), 'wb').write(data)
    self.image.set_from_file(self._getResource('img.jpg'))
    attr = self.attrs[self.curr]
    self.link.set_label(attr.string)
    self.link.set_property('url', attr['href'])
    
  def _onCancel(self, widget):
    self._signal(self.CANCEL)
